package encryptionproject;

import java.awt.*;

class EncryptionColumnarMethod extends EncryptionMethod
{

    public EncryptionColumnarMethod()
    {
    }

    public String encrypt(String s, TutorialDisplay tutorialdisplay)
    {
        String s1 = "";
        try
        {
            int j = (new Integer(txtColumns.getText())).intValue();
            int i = s.length() / j + 1;
            if(j > 0)
            {
                int k1 = 0;
                tutorialdisplay.addText("\n===============\nColumnar Transposition with " + j + " columns\n\n");
                for(int k = 0; k < s.length(); k++)
                {
                    k1++;
                    tutorialdisplay.addText(s.charAt(k) + " ");
                    if(k1 >= j)
                    {
                        k1 = 0;
                        tutorialdisplay.addText("\n");
                    }
                }

                int ai[][] = new int[i][j];
                for(int l = 0; l < i; l++)
                {
                    for(int l1 = 0; l1 < j; l1++)
                        ai[l][l1] = -1;

                }

                for(int i1 = 0; i1 < i; i1++)
                {
                    for(int i2 = 0; i2 < j; i2++)
                        if(s.length() > i1 * j + i2)
                            ai[i1][i2] = s.charAt(i1 * j + i2);

                }

                for(int j2 = 0; j2 < j; j2++)
                {
                    for(int j1 = 0; j1 < i; j1++)
                        if(ai[j1][j2] > -1)
                            s1 = s1 + (char)ai[j1][j2];

                }

            } else
            {
                s1 = "Number of Columns must be greater than zero";
            }
        }
        catch(NumberFormatException numberformatexception)
        {
            s1 = "Number of Columns not Valid";
        }
        return s1;
    }

    public Panel getOptionsPanel()
    {
        Panel panel = new Panel(new FlowLayout(0));
        panel.add(new Label("Number of columns to use: "));
        txtColumns = new TextField(2);
        txtColumns.setBackground(Color.white);
        txtColumns.setText("1");
        panel.add(txtColumns);
        panel.setBackground(new Color(192, 0, 0));
        return panel;
    }

    private TextField txtColumns;
}
