package encryptionproject;

import java.awt.*;

class EncryptionPolyalphabeticMethod extends EncryptionMethod
{

    public EncryptionPolyalphabeticMethod()
    {
    }

    private String formatKey(String s)
    {
        String s2 = s.toUpperCase();
        String s1 = "";
        for(int i = 0; i < s2.length(); i++)
            if(Character.isLetter(s2.charAt(i)) && s1.indexOf(s2.charAt(i)) <= -1)
                s1 = s1 + s2.charAt(i);

        int k = s1.length();
        for(int j = k; j < 26; j++)
        {
            boolean flag = false;
            for(char c = 'A'; !flag; c++)
                if(s1.indexOf(c) < 0)
                {
                    flag = true;
                    s1 = s1 + c;
                }

        }

        return s1;
    }

    public String encrypt(String s, TutorialDisplay tutorialdisplay)
    {
        boolean flag = false;
        tutorialdisplay.addText("\n===============\nPolyalphabetic Encryption\n\n");
        String s1 = txtKeyOdd.getText();
        String s2 = txtKeyEven.getText();
        s1 = formatKey(s1);
        s2 = formatKey(s2);
        tutorialdisplay.addText("Key for odd characters: " + s2 + "\n");
        tutorialdisplay.addText("Key for even characters: " + s1 + "\n");
        txtKeyOdd.setText(s1);
        txtKeyEven.setText(s2);
        String s4 = s.toUpperCase();
        String s3 = "";
        for(int i = 0; i < s4.length(); i++)
            if(i % 2 == 1)
                s3 = s3 + s1.charAt(s4.charAt(i) - 65);
            else
                s3 = s3 + s2.charAt(s4.charAt(i) - 65);

        return s3;
    }

    public Panel getOptionsPanel()
    {
        Panel panel = new Panel(new BorderLayout());
        txtKeyEven = new TextField(26);
        txtKeyOdd = new TextField(26);
        Label label = new Label("Enter key for Odd Characters");
        Label label1 = new Label("Enter Key for Even Characters");
        Panel panel1 = new Panel();
        panel1.add(label);
        panel1.add(txtKeyEven);
        panel.add(panel1, "North");
        panel1 = new Panel();
        panel1.add(label1);
        panel1.add(txtKeyOdd);
        panel.add(panel1, "Center");
        panel.setBackground(new Color(192, 255, 192));
        return panel;
    }

    private TextField txtKeyOdd;
    private TextField txtKeyEven;
}
