package encryptionproject;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

class TutorialDisplay extends Panel
    implements ActionListener
{

    public TutorialDisplay()
    {
        setup();
        txt.setFont(EncryptionProject.CODE_FONT);
    }

    private void setup()
    {
        txt = new TextArea("", 20, 22, 1);
        txt.setBackground(Color.black);
        txt.setForeground(Color.white);
        txt.setEditable(false);
        isDisabled = false;
        setBackground(new Color(192, 192, 192));
        setLayout(new BorderLayout());
        add(new Label("Console"), "North");
        add(txt, "Center");
        Panel panel = new Panel(new FlowLayout(0));
        butDisable = new Button("Disable");
        butDisable.addActionListener(this);
        panel.add(butDisable);
        butWindow = new Button("Win");
        butWindow.addActionListener(this);
        panel.add(butWindow);
        butClear = new Button("Clear");
        butClear.addActionListener(this);
        panel.add(butClear);
        add(panel, "South");
    }

    public void addText(String s)
    {
        if(!isDisabled)
        {
            txt.append(s + " ");
            if(txt.getText().length() > 20000)
                txt.setText(txt.getText().substring(txt.getText().length() - 20000, txt.getText().length()));
        }
    }

    public void actionPerformed(ActionEvent actionevent)
    {
        String s = actionevent.getActionCommand();
        if(s.equals("Disable"))
        {
            isDisabled = true;
            txt.setBackground(Color.red);
            butDisable.setLabel("Enable");
        } else
        if(s.equals("Enable"))
        {
            isDisabled = false;
            txt.setBackground(Color.black);
            butDisable.setLabel("Disable");
        } else
        if(s.equals("Clear"))
            txt.setText("");
        else
        if(s.equals("Win"))
        {
            Frame frame = new Frame();
            _cls1 _lcls1 = new  Object(frame);     /* anonymous class not found*/
    class _anm1 {}

;
            frame.addWindowListener(_lcls1);
            frame.add(this);
            frame.setLocation(128, 128);
            frame.setSize(640, 480);
            frame.setVisible(true);
            txt.setFont(new Font("monospaced", 0, 14));
            add(new Panel(), "South");
        }
    }

    public static final String DISABLE = "Disable";
    public static final String ENABLE = "Enable";
    public static final String WINDOW = "Win";
    public static final String CLEAR = "Clear";
    boolean isDisabled;
    private TextArea txt;
    private Button butDisable;
    private Button butWindow;
    private Button butClear;
}
